#ifndef DEF_HEADER_BCH
#define DEF_HEADER_BCH

#include "generic_poly.h"

typedef struct _BCH BCH;
struct _BCH
{
	GenPolyF2 g;
	GenPolyF2 h;
	int len;
	int msg_len;
	int nb_correct;
	GenPolyF2 based_poly;
};

int BCH_create(BCH * code, const GenPolyF2 * constructor, int nb_correct);

void BCH_free(BCH * code);

void BCH_print(const BCH * code);

int BCH_code(const BCH * code, GenPolyF2 * res, const GenPolyF2 * message);

int BCH_decode(const BCH * code, GenPolyF2 * res, const GenPolyF2 * message);

int BCH_is_error(const BCH * code, const GenPolyF2 * message);

int Hamming_distance(const GenPolyF2 * poly);

int max_correct(int based_poly_degree);

#endif