#ifndef DEF_HEADER_MATRICE_F2
#define DEF_HEADER_MATRICE_F2

#include "generic_poly.h"

typedef struct _MatriceF2 MatriceF2;
struct _MatriceF2
{
	unsigned char * seq;
	int lignes;
	int colonnes;
};

int MatriceF2_create(MatriceF2 * mat, int lignes, int colonnes);

int MatriceF2_create_identity(MatriceF2 * mat, int lignes);

int MatriceF2_copy(MatriceF2 * dest, const MatriceF2 * src);

void MatriceF2_free(MatriceF2 * mat);

int MatriceF2_set_val(MatriceF2 * mat, unsigned char val, int ligne, int colonne);

int MatriceF2_add_val(MatriceF2 * mat, unsigned char val, int ligne, int colonne);

int MatriceF2_get_val(const MatriceF2 * mat, unsigned char * val, int ligne, int colonne);

int MatriceF2_poly_to_colonne(MatriceF2 * mat, const GenPolyF2 * poly, int colonne);

int MatriceF2_poly_to_ligne(MatriceF2 * mat, const GenPolyF2 * poly, int line);

int MatriceF2_poly_from_colonne(const MatriceF2 * mat, GenPolyF2 * poly, int colonne);

int MatriceF2_poly_from_ligne(const MatriceF2 * mat, GenPolyF2 * poly, int line);

int MatriceF2_apply_gauss_ligne(MatriceF2 * mat, MatriceF2 * calc);

int MatriceF2_apply_gauss_colonne(MatriceF2 * mat, MatriceF2 * calc);

int MatriceF2_sub_lignes(MatriceF2 * mat, int l1, int l2);

int MatriceF2_sub_colonnes(MatriceF2 * mat, int c1, int c2);

int MatriceF2_get_ker_id(MatriceF2 * mat, GenPolyF2 ** bases, int * nb_bases);

int MatriceF2_Berlekamp(MatriceF2 * mat, const GenPolyF2 * poly);

void MatriceF2_print(const MatriceF2 * mat);

int MatriceF2_is_null_colonne(const MatriceF2 * mat);

#endif