#ifndef DEF_PETERSON_SOLVE_HEADER
#define DEF_PETERSON_SOLVE_HEADER

#include "generic_poly.h"

typedef struct _PMatrice PMatrice;
struct _PMatrice
{
	GenPolyF2 * seq;
	int lignes;
	int colonnes;
	GenPolyF2 based_poly;
};

int PMatrice_create(PMatrice * matrice, int lignes, int colonnes, const GenPolyF2 * based_poly);

int PMatrice_syndrom_create(PMatrice * matrice, const GenPolyF2 * syndroms, int nb_correct, const GenPolyF2 * based_poly);

void PMatrice_free(PMatrice * matrice);

GenPolyF2 * PMatrice_val(PMatrice * matrice, int ligne, int colonne);

void PMatrice_print(PMatrice * matrice);

int PMatrice_mul_line(PMatrice * matrice, int ligne, const GenPolyF2 * poly);

int PMatrice_add_lines(PMatrice * matrice, int ligne_un, int ligne_deux);

int PMatrice_swap_lines(PMatrice * matrice, int ligne_un, int ligne_deux);

int PMatrice_reduce(PMatrice * matrice, int id);

int PMatrice_solve(PMatrice * matrice);

int Peterson_solve(const GenPolyF2 * based_poly, const GenPolyF2 * syndroms, int nb_correct, GenPolyF2 ** racines);

int Gauss_solve(const GenPolyF2 * based_poly, const GenPolyF2 * syndroms, int nb_correct, GenPolyF2 ** solutions, int * nb_solutions);

#endif