#ifndef DEF_HEADER_QR_DATA
#define DEF_HEADER_QR_DATA

#include "qr_code.h"

typedef enum
{
	QRD_TERMINATOR =	0x0,
	QRD_NUMERIC =		0x1,
	QRD_ALPHANUMERIC =	0x2,
	QRD_STRUCTURED_APPEND =	0x3,
	QRD_BYTE =		0x4,
	QRD_FNC1_1 =		0x5,
	QRD_ECI	=		0x7,
	QRD_KANJI =		0x8,
	QRD_FNC1_2 =		0x9
} QRD_Mode;

typedef struct _QRData QRData;
struct _QRData
{
	QRD_Mode mode;
	unsigned int infos;
	int data_size;
	int final_data_size;
	unsigned char * data;
	unsigned char * final_data;
};

int QRData_create(QRData * data, QRD_Mode mode, int data_size);

void QRData_free(QRData * data);

int get_message(const unsigned char * data, unsigned char ** message);

int QRData_create_text(QRData * data, const char * text);

int QRData_create_numeric(QRData * data, const char * numbers);

int QRData_create_alphanumeric(QRData * data, const char * text);

int QRData_create_byte(QRData * data, const char * bit_seq, int nb_bytes);

int QRData_make_code(QRData * data, QRCode * code, int version, CorrectionLevel cl, int mask_id);

void QRData_print(const QRData * data);

#endif