#ifndef DEF_HEADER_REED_SOLOMON
#define DEF_HEADER_REED_SOLOMON

#include "generic_poly.h"
#include "construct_poly.h"

typedef struct _RS RS;
struct _RS
{
	CPoly g;
	GenPolyF2 based_poly;
	int nb_correct;
	int nb_words;
};

int RS_create(RS * rs, const GenPolyF2 * based_poly, int nb_correct);

void RS_free(RS * rs);

int RS_code(RS * rs, const CPoly * data_poly, CPoly * coded_poly);

int RS_decode(RS * rs, CPoly * coded_poly, CPoly * data_poly);

void RS_print(const RS * rs);

int RS_code_chars(RS * rs, int nb_codewords, const unsigned char * chaine, CPoly * coded_poly);

int hexa_str_to_chars(const char * hexa_str, char ** chaine);

#endif