#include "test_control.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <string.h>

static int var_continue = 0;
static int nb_int = 0;
static struct sigaction old_signal;

void TC_stop(int var)
{
	var_continue = 0;
	++nb_int;
	if(nb_int >= 2)
		sigaction(SIGINT, &old_signal, NULL);
}

int TC_init()
{
	struct sigaction new_signal;
	memset(&new_signal, 0, sizeof(struct sigaction));
	new_signal.sa_handler = &TC_stop;
	sigaddset(&(new_signal.sa_mask), SIGINT);
	if(sigaction(SIGINT, &new_signal, &old_signal) == -1)
		return 0;
	var_continue = 1;
	nb_int = 0;
	return 1;
}

int TC_continue()
{
	return var_continue;
}

int TC_quit()
{
	var_continue = 0;
	if(sigaction(SIGINT, &old_signal, NULL) == -1)
		return 0;
	return 1;
}